#include <DS3232RTC.h>//ライブラリーをインクルード
void setup() {
DDRD = DDRD | B11111100;      //D7 6 5 4 3 2 1 0 の入出力設定（1で出力　0で入力）
DDRB = DDRB | B00111111;      //D * * 13 12 11 10 9 8の入出力設定（1で出力　0で入力）
DDRC = DDRC | B00000000;      //A* * 5 4 3 2 1 0の入出力設定（1で出力　0で入力）
pinMode(A0,INPUT_PULLUP);
pinMode(A1,INPUT_PULLUP);     //SW1タクトスイッチの入力設定（内部プルアップ）
}
boolean Number_Array[10][7]={    //Number_Array[数字の数][セグ数]
{1,0,0,0,0,0,0},//0 {g,f,a,b,e,d,c}で入力。1がOFF,0がON(アノードコモンのため) 
{1,1,1,0,1,1,0},//1
{0,1,0,0,0,0,1},//2
{0,1,0,0,1,0,0},//3
{0,0,1,0,1,1,0},//4
{0,0,0,1,1,0,0},//5
{0,0,0,1,0,0,0},//6
{1,0,0,0,1,1,0},//7
{0,0,0,0,0,0,0},//8
{0,0,0,0,1,0,0} //9
};
//LED表示関数を定義
void Number(int x){
  int z[]={10,11,12,13,9,8,7};      //{g,f,a,b,e,d,c}で入力
  for (int seg=0; seg<=6; seg++){
    digitalWrite(z[seg],-Number_Array[x][seg]);
  }
}
void loop(){  
  PORTD |= 0b11111100;      //D7 6 5 4 3 2をHIGH（一旦非表示にする）
  PORTB |= 0b00111111;      //D * * 13 12 11 10 9 8をHIGH（一旦非表示にする）
  int com[]={6,5,3,2};      //COMポートを設定{comA,comB,comC,comD}
  int y[]={0,0,0,0};        //各桁に表示する数字の変数を宣言{時,時,分,分}
  tmElements_t tm;
  RTC.read(tm);
  y[0]= tm.Hour/10;           
  y[1]= tm.Hour%10;
  y[2]= tm.Minute/10;
  y[3]= tm.Minute%10;
  int dots = tm.Second%2;
  digitalWrite(4,dots);
  for(int i=0;i<=3;i++){        //ダイナミック点灯のループ
     digitalWrite(com[i],LOW);   //表示する桁を開ける
     int x=y[i];                 //その桁で表示する数字をxに代入
     Number(x);                  //xの数字を表示する
     delay(3);
     digitalWrite(com[i],HIGH);  //表示した桁を閉じる    
  }
  if(digitalRead(A0)==LOW){
      delay(250);
      if(digitalRead(A0)==LOW){
        setTime(tm.Hour+1, tm.Minute ,0,0,0,0);//時、分、秒、日、月、年の順で入力
        RTC.set(now());//初期設定時間の書き込み
      }
  }
  if(digitalRead(A1)==LOW){
      delay(250);
      if(digitalRead(A1)==LOW){
        setTime(tm.Hour, tm.Minute+1 ,0,0,0,0);//初期設定　時、分、秒、日、月、年の順で入力
        RTC.set(now());//初期設定時間の書き込み
      }
  }
}
